#include "const.h"
#include <stdio.h>

#define ALTA 1
#define BAJA 2
#define TASA_ALTA 5
#define TASA_BAJA 6
#define DIGIT   8


alarmas()
{
  int tabla, indice;          	
  short estado;
  int i; 
  real valor, al_min, al_max;
  char nombre[TAM_NOM], nom_disp[TAM_NOM];
  char almid[TAM_NOM], procedim[TAM_NOM];
  int frec, cant_ref, cuando;
  char prio; 
  time_t *timer1, *timer2;
  time_t tpo_transcurrido, tpo_anterior, tpo_actual, tpo_esperado;
  extern void readmem(), qwrite();
  extern get_alm_q(), put_alm_q();
  extern int pp_to_display[], pp_to_input[];
  int lanzar();
#ifdef RT
  extern int pp_tasa[];
  setper(T_ALARM,C_ALARM);
#endif

  signal(SIGUSR2, SH);

  close(pp_to_display[0]);
  close(pp_to_display[1]);
  close(pp_to_input[0]);
  close(pp_to_input[0]);
#ifdef RT
  close(pp_tasa[0]);
  close(pp_tasa[1]);
#endif

  tpo_anterior = time(timer1);
  
  while(SIEMPRE)
  { 
#ifndef RT
	signal(PETATE, shh);  
	pause();
#endif
#ifdef RT
   	inst_end();
#endif
#ifdef COSO1
	printf("Se desperto la Alarma \n");
#endif

	tpo_actual = time(timer2);
	tpo_transcurrido = tpo_actual - tpo_anterior;
	tpo_anterior = tpo_actual; 
	
	for (i=0;
	     get_alm_q(i, almid, &tabla, &indice, nombre, &frec, &prio, 
	      procedim, &cuando, &al_min, &al_max, &tpo_esperado, &cant_ref);
	     i++)
	  
	   if ( (tpo_transcurrido + tpo_esperado) < (long) frec)
		{
		tpo_esperado += tpo_transcurrido;
		put_alm_q(i, almid, tabla, indice, nombre, frec, prio, procedim, cuando,
		     al_min, al_max, tpo_esperado, cant_ref);
		}
	   else
		{
		readmem(tabla, indice, &valor, &estado);	
		printf("Referencias: %d, al_min %ld, al_max %ld, cuando %d\n", cant_ref, al_min, al_max, cuando);
		if (tabla == DIG)
	   	  {		
		  if (cant_ref != 0)
			{
			printf("Entro a DIG\n");
			qwrite(tabla, indice, valor, DA);
			grabar(nombre);
			lanzar(procedim, DA, prio, almid, tabla, indice);
			}		
		  }
		else
		 switch(cuando)
		   {
		   case ALTA: if (valor > al_max)
				{
			   	qwrite(tabla, indice, valor, HI);
				lanzar(procedim, HI, prio, almid, tabla, indice);
				grabar(nombre);
				}
			     break;

		   case BAJA: if (valor < al_min)
				{
				qwrite(tabla, indice, valor, LO);
				lanzar(procedim, LO, prio, almid, tabla, indice);
				grabar(nombre);
				}
			     break;

		  case TASA_ALTA: /*verificar tasa*/
				printf("Entro a Tasa Alta \n");
				if (cant_ref > (int) (al_max/100000L))
				{
			  	printf("Sigue\n");	
				qwrite(tabla, indice, valor, SA);
				grabar(nombre);
				lanzar(procedim, SA, prio, almid, tabla, indice);
				}
				  break;

		  case TASA_BAJA: /* verificar  tasa */
				printf("Entro a tasa Baja\n");
				if (cant_ref < (int) (al_min/100000L))
				  {
				  printf("Sigue\n");
				  qwrite(tabla, indice, valor, SA);
				  grabar(nombre);
				  lanzar(procedim, SA, prio, almid, tabla, indice);
				  }
				  break;

		  } /* switch */

		put_alm_q(i, almid, tabla, indice, nombre, frec, prio,
		  procedim, cuando, al_min, al_max, 0, 0); 
	
		} /* else */

  } /* while */

} /* funcion */

lanzar(procedimiento, estado, prio, almid, tabla, indice)
char procedimiento[], almid[];
short estado;
char prio;
int tabla, indice;
{
   int status;
   pid_t resul_fork;
   int i;
   extern char *decodificar();
   real valor;

/*
   readmem(tabla, indice, &valor, &estado);
   if (estado == TODO_OK || estado == DK || estado == HK || estado == LK
		      || estado == SK)  return;
*/

   if (strcmp(procedimiento, "default") == 0) 
	{
	/* clscr(); */
	switch(prio)
  	  {
	case 'A': printf("Atencion !: %s - %s\n", decodificar(estado), almid);
		  break;
	
	case 'P': printf("Precaucion!: %s - %s\n", decodificar(estado), almid);
		  for (i=0; i<=30; i++) putchar('\7');
		  break;
	
	case 'U': signal(PETATE, SH);
		  while( estado != TODO_OK && estado != DK
		      && estado != HK && estado != LK
		      && estado != SK)
		  {
		     clscr();
		     printf("URGENTE!!!! %s - %s", decodificar(estado), almid);
 		     for (i=0; i<=300; i++) putchar('\7');
		     readmem(tabla, indice, &valor, &estado);
		     sleep(1);
		  }
		  break;
	  } /* Switch */
	} /* if */
   else
	{
		if((resul_fork = fork()) != 0)
		   wait(&status);    /* padre */
		else
		   execl(procedimiento, procedimiento, 0);
	}
}

grabar(nombre)
char nombre[];
{
  FILE *arch_nom;

	arch_nom = fopen("/tmp/nombre", "w");
	fprintf(arch_nom, "%10s\n", nombre);
	fclose(arch_nom);
}
