#include "const.h"
#include <stdio.h>
#include <time.h>

int pp_to_display[2], pp_to_input[2];
#ifdef RT
int pp_tasa[2];
pid_t pids[CANT_TAREAS];
#endif

main()
{
  /* Se despierta cada determinado tiempo. Verifica que tareas tiene que 
	despertar, y les dice: PETATE! */

  time_t tpo_transcurrido, tpo_anterior, tpo_actual, 
			tpo_esperado;
  int tpo_de_periodo;
  extern void panico();
  extern inicializa(), put_task_q(), get_task_q();
  time_t *timer1, *timer2;
  pid_t pid;
  int i, nro_tarea;

  pipe(&pp_to_display[0]);
  pipe(&pp_to_input[0]);
#ifdef RT
  pipe(&pp_tasa[0]);
#endif
  inicializa();
#ifdef RT
  setper(T_SINCR,C_SINCR);  
  close(pp_tasa[0]);
  close(pp_tasa[1]);
#endif
  close(pp_to_display[0]);
  close(pp_to_display[1]);
  close(pp_to_input[0]);
  close(pp_to_input[1]);

  tpo_anterior = time(timer1);

  while(SIEMPRE)
	{
  	if (!be_safe())
		{
		panico(KILL, "Un proceso murio \n");
#ifdef RT
		for(nro_tarea = 0; nro_tarea < CANT_TAREAS; nro_tarea ++) {
			kill(pids[nro_tarea],9);
		}
#endif
		exit(-1);
		}
#ifndef RT
	tpo_actual = time(timer2);
	tpo_transcurrido = tpo_actual - tpo_anterior;
	tpo_anterior = tpo_actual;

	for(i=0; get_task_q(i, &tpo_esperado, &tpo_de_periodo, &pid); i++)

#ifdef COSO1
	  { 
	  printf("tpo_transc %ld, tpo_esperado %ld\n", tpo_transcurrido, 
				tpo_esperado);
	  printf("tpo_periodo %d, pid %d\n", tpo_de_periodo, pid);
#endif

	  if ( ((tpo_transcurrido + tpo_esperado) >= tpo_de_periodo) 
				&& tpo_de_periodo != INTERACTIVA)
		{
		put_task_q(i, (time_t) 0, tpo_de_periodo, pid);
		kill(pid, PETATE);
		}
	   else
		{
		tpo_esperado += tpo_transcurrido;
		put_task_q(i, tpo_esperado, tpo_de_periodo, pid);
		}
#ifdef COSO1
	  }  /* for: volarlo */ 
#endif

	/* unlock(); */
#endif
#ifdef RT
	    inst_end();
#endif
	} /* while */

} /* funcion */
