#include "const.h"
#include <stdio.h>
#include <fcntl.h>


display()
{
   int tabla, indice;
   int i, alarma;
   short estado;
   char nom_proc[TAM_NOM], nombre[TAM_NOM], nom_disp[TAM_NOM];
   real valor;
   real al_min, al_max;
   extern void readmem(), writemem(), clscr();
   extern int pp_to_display[], pp_to_input[];   /*  Pipes */
   char *decodificar();
   extern void initscr(), clear();
   int porcent;

#ifdef RT
   void disp();
   extern int pp_tasa[];
   int tpo_per;
   int nvo_tpo_per;
   char tpo_per_s[3];
   setper(T_DISPLAY,C_DISPLAY);
   signal(PETATE, disp);
   tpo_per = 1;
#endif

   signal(SIGUSR2, SH);
   strcpy(nom_proc, Off); 
   close(pp_to_input[0]);

   while(SIEMPRE)
	{ 
#ifndef RT
	signal(PETATE, shh);
	pause();
  	signal(PETATE, SH); 
#endif
	read(pp_to_display[0], nom_proc, TAM_NOM);
#ifndef RT
	signal(PETATE, shh);
#endif
#ifdef RT
	read(pp_tasa[0],tpo_per_s,3);
	nvo_tpo_per = atoi(tpo_per_s);
	inst_end();
	if(nvo_tpo_per != tpo_per) {
		tpo_per = nvo_tpo_per;
		setper(tpo_per,C_DISPLAY);
	}
#endif
   	if ( strcmp(nom_proc, Off) != 0) /* Lei el comando que apaga */
   	{
 /*		clscr();*/  

#ifdef COSO1
	printf("leyo pipe, nom_proc %s", nom_proc);
#endif
		printf("Proceso: %s \n\n", nom_proc);
		printf("Dispositivo  Tabla   Indice      Estado    Valor  \n");
		printf("---------------------------------------------------\n");

		for(i=0;
		   get_proc(i, &tabla, &indice, nombre, nom_disp, porcent);
		   i++)
	  
		   if(!strcmp(nom_proc, nombre))
			{
			readmem(tabla, indice, &valor, &estado);
			printf("%10s %5d %8d %11s ", nom_disp, tabla, indice, 
				decodificar(estado) );

			print_real(STDOUT, valor); 
       		        printf("\n");

		   } /* if */



   	} /* If NOT OFF */
#ifdef RT
	write(pp_tasa[1],itoa(nvo_tpo_per),3);
#endif
 	write(pp_to_display[1], nom_proc, TAM_NOM);
   } /* while */
}


char *decodificar(estado)
int estado;
{
   extern char *estados[];

   if (estado > CANT_ESTADOS) return("ERROR");
   return(estados[estado]);
}

#ifdef RT
void disp() 
{
	int tabla, indice;
	int i;
	short estado;
	char nom_proc[TAM_NOM], nombre[TAM_NOM], nom_disp[TAM_NOM];
	real valor;
	real al_min, al_max;
	int porcent;
   
	printf("Proceso: %s \n\n", nom_proc);
	printf("Dispositivo  Tabla   Indice      Estado    Valor  \n");
	printf("---------------------------------------------------\n");

	for(i=0;
	get_proc(i, &tabla, &indice, nombre, nom_disp, porcent);i++)
	if(!strcmp(nom_proc, nombre)) {
		readmem(tabla, indice, &valor, &estado);
		printf("%10s %5d %8d %11s ", nom_disp, tabla, indice, 
		decodificar(estado) );
		print_real(STDOUT, valor); 
       		printf("\n");
	}
	signal(PETATE, disp);
}
#endif
